org.jboss.netty.handler.codec.http.multipart

## Interface HttpData

- All Superinterfaces:
    Comparable<InterfaceHttpData>, InterfaceHttpData
  All Known Subinterfaces:
    Attribute, FileUpload
  All Known Implementing Classes:
    AbstractDiskHttpData, AbstractHttpData, AbstractMemoryHttpData, DiskAttribute, DiskFileUpload, MemoryAttribute, MemoryFileUpload, MixedAttribute, MixedFileUpload

      public interface HttpData
      extends InterfaceHttpData

  Extended interface for InterfaceHttpData

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.jboss.netty.handler.codec.http.multipart.InterfaceHttpData

      `InterfaceHttpData.HttpDataType`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addContent(ChannelBuffer buffer, boolean last)` Add the content from the ChannelBuffer
    `void` | `delete()` Deletes the underlying storage for a file item, including deleting any associated temporary disk file.
    `byte[]` | `get()` Returns the contents of the file item as an array of bytes.
    `ChannelBuffer` | `getChannelBuffer()` Returns the content of the file item as a ChannelBuffer
    `Charset` | `getCharset()` Returns the Charset passed by the browser or null if not defined.
    `ChannelBuffer` | `getChunk(int length)` Returns a ChannelBuffer for the content from the current position with at most length read bytes, increasing the current position of the Bytes read.
    `File` | `getFile()`
    `String` | `getString()` Returns the contents of the file item as a String, using the default character encoding.
    `String` | `getString(Charset encoding)` Returns the contents of the file item as a String, using the specified charset.
    `boolean` | `isCompleted()`
    `boolean` | `isInMemory()` Provides a hint as to whether or not the file contents will be read from memory.
    `long` | `length()` Returns the size in byte of the InterfaceHttpData
    `boolean` | `renameTo(File dest)` A convenience method to write an uploaded item to disk.
    `void` | `setCharset(Charset charset)` Set the Charset passed by the browser if defined
    `void` | `setContent(ChannelBuffer buffer)` Set the content from the ChannelBuffer (erase any previous data)
    `void` | `setContent(File file)` Set the content from the file (erase any previous data)
    `void` | `setContent(InputStream inputStream)` Set the content from the inputStream (erase any previous data)

    - ### Methods inherited from interface org.jboss.netty.handler.codec.http.multipart.InterfaceHttpData

      `getHttpDataType, getName`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Method Detail

    - #### setContent

          void setContent(ChannelBuffer buffer)
                          throws IOException

      Set the content from the ChannelBuffer (erase any previous data)
      Parameters:
        `buffer` - must be not null
      Throws:
        `IOException`

    - #### addContent

          void addContent(ChannelBuffer buffer,
                        boolean last)
                          throws IOException

      Add the content from the ChannelBuffer
      Parameters:
        `buffer` - must be not null except if last is set to False
        `last` - True of the buffer is the last one
      Throws:
        `IOException`

    - #### setContent

          void setContent(File file)
                          throws IOException

      Set the content from the file (erase any previous data)
      Parameters:
        `file` - must be not null
      Throws:
        `IOException`

    - #### setContent

          void setContent(InputStream inputStream)
                          throws IOException

      Set the content from the inputStream (erase any previous data)
      Parameters:
        `inputStream` - must be not null
      Throws:
        `IOException`

    - #### isCompleted

          boolean isCompleted()

      Returns:
        True if the InterfaceHttpData is completed (all data are stored)

    - #### length

          long length()

      Returns the size in byte of the InterfaceHttpData
      Returns:
        the size of the InterfaceHttpData

    - #### delete

          void delete()

      Deletes the underlying storage for a file item, including deleting any associated temporary disk file.

    - #### get

          byte[] get()
                     throws IOException

      Returns the contents of the file item as an array of bytes.
      Returns:
        the contents of the file item as an array of bytes.
      Throws:
        `IOException`

    - #### getChannelBuffer

          ChannelBuffer getChannelBuffer()
                                         throws IOException

      Returns the content of the file item as a ChannelBuffer
      Returns:
        the content of the file item as a ChannelBuffer
      Throws:
        `IOException`

    - #### getChunk

          ChannelBuffer getChunk(int length)
                                 throws IOException

      Returns a ChannelBuffer for the content from the current position with at most length read bytes, increasing the current position of the Bytes read. Once it arrives at the end, it returns an EMPTY_BUFFER and it resets the current position to 0.
      Parameters:
        `length` -
      Returns:
        a ChannelBuffer for the content from the current position or an EMPTY_BUFFER if there is no more data to return
      Throws:
        `IOException`

    - #### getString

          String getString()
                           throws IOException

      Returns the contents of the file item as a String, using the default character encoding.
      Returns:
        the contents of the file item as a String, using the default character encoding.
      Throws:
        `IOException`

    - #### getString

          String getString(Charset encoding)
                           throws IOException

      Returns the contents of the file item as a String, using the specified charset.
      Parameters:
        `encoding` - the charset to use
      Returns:
        the contents of the file item as a String, using the specified charset.
      Throws:
        `IOException`

    - #### setCharset

          void setCharset(Charset charset)

      Set the Charset passed by the browser if defined
      Parameters:
        `charset` - Charset to set - must be not null

    - #### getCharset

          Charset getCharset()

      Returns the Charset passed by the browser or null if not defined.
      Returns:
        the Charset passed by the browser or null if not defined.

    - #### renameTo

          boolean renameTo(File dest)
                           throws IOException

      A convenience method to write an uploaded item to disk. If a previous one exists, it will be deleted. Once this method is called, if successful, the new file will be out of the cleaner of the factory that creates the original InterfaceHttpData object.
      Parameters:
        `dest` - destination file - must be not null
      Returns:
        True if the write is successful
      Throws:
        `IOException`

    - #### isInMemory

          boolean isInMemory()

      Provides a hint as to whether or not the file contents will be read from memory.
      Returns:
        True if the file contents is in memory.

    - #### getFile

          File getFile()
                       throws IOException

      Returns:
        the associated File if this data is represented in a file
      Throws:
        `IOException` - if this data is not represented by a file

Copyright © 2008-2012 The Netty Project. All Rights Reserved.